(* ::Package:: *)

(* AutoDipole 1.2.1 - Package of an automated dipole subtraction by
Kouhei Hasegawa, Sven Moch, and Peter Uwer *)


(* Write shell script to controll MadGraph  
1.createcolor: Return allcolor.data
2.createamplitude: Return cmatrix
3.createemitspecinfo: Return emitters for fortran input
4.createnexternal
5.write check.f
6.write checkIR.f
7.write plotall
*)


(* 1.createcolor *)


createcolor:=Module[{},
namegetallcolorsh=StringJoin[targettempdir,"/getallcolor.sh"];
str3=OpenWrite[namegetallcolorsh];
WriteString[str3,"#!/bin/sh"];
WriteString[str3," \n \n"];
WriteString[str3,". ../../../lib/sh/AutoDipoleTool.sh"];
WriteString[str3," \n\n"];
WriteString[str3,"rm -f allcolormat1.inc \n"];
WriteString[str3,"rm -f allcolormat2u.inc \n"];
WriteString[str3,"rm -f allcolormat2d.inc \n"];
WriteString[str3,"rm -f allcolormat2b.inc \n"];
WriteString[str3,"rm -f allcolormat2t.inc \n"];
WriteString[str3,"rm -f allcolormat3u.inc \n"];
WriteString[str3,"rm -f allcolormat3ubar.inc \n"];
WriteString[str3,"rm -f allcolormat3d.inc \n"];
WriteString[str3,"rm -f allcolormat3dbar.inc \n"];
WriteString[str3,"rm -f allcolormat4u.inc \n"];
WriteString[str3,"rm -f allcolormat4ubar.inc \n"];
WriteString[str3,"rm -f allcolormat4d.inc \n"];
WriteString[str3,"rm -f allcolormat4dbar.inc \n"];
WriteString[str3,"rm -f tempc1 tempc2 \n"];
WriteString[str3," \n"];
WriteString[str3," \n"];

(* Dipole 1 *)

If[dAs != 0,
WriteString[str3,"# M0=B1:",{A[1],A[2]}," --> ",A1];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=A[1];BL[2]=A[2];
Do[BL[k+2]=Part[A1,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
writeshells[1,dAs];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat1.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

(* Dipole 2 *)

If[dss[51] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str3,"# M0=B2u:     ",{A[1],A[2]}," --> ", A2a1];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
Do[BL[k+2]=Part[A2a1,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs;
writeshells[tempcount+1,tempcount+dss[51]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat2u.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[53] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str3,"# M0=B2d:     ",{A[1],A[2]}," --> ", A2a2];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
Do[BL[k+2]=Part[A2a2,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dss[51];
writeshells[tempcount+1,tempcount+dss[53]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat2d.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[57] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str3,"# M0=B2b: ",{A[1],A[2]}," --> ", A2a4];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
Do[BL[k+2]=Part[A2a4,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dss[51]+dss[53];
writeshells[tempcount+1,tempcount+dss[57]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat2b.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[58] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str3,"# M0=B2t: ",{A[1],A[2]}," --> ", A2a3];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
Do[BL[k+2]=Part[A2a3,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dss[51]+dss[53]+dss[57];
writeshells[tempcount+1,tempcount+dss[58]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat2t.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

(* Dipole 3 *)

If[dss[61] != 0,
WriteString[str3,"# M0=B3u: ",A3a1in," --> ", A3a1];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A3a1in,1];BL[2]=Part[A3a1in,2];
Do[BL[k+2]=Part[A3a1,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs;
writeshells[tempcount+1,tempcount+dss[61]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat3u.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[62] != 0,
WriteString[str3,"# M0=B3ubar: ",A3a2in," --> ", A3a2];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A3a2in,1];BL[2]=Part[A3a2in,2];
Do[BL[k+2]=Part[A3a2,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dss[61];
writeshells[tempcount+1,tempcount+dss[62]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat3ubar.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[63] != 0,
WriteString[str3,"# M0=B3d: ",A3a3in," --> ", A3a3];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A3a3in,1];BL[2]=Part[A3a3in,2];
Do[BL[k+2]=Part[A3a3,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dss[61]+dss[62];
writeshells[tempcount+1,tempcount+dss[63]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat3d.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[64] != 0,
WriteString[str3,"# M0=B3dbar: ",A3a4in," --> ", A3a4];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A3a4in,1];BL[2]=Part[A3a4in,2];
Do[BL[k+2]=Part[A3a4,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dss[61]+dss[62]+dss[63];
writeshells[tempcount+1,tempcount+dss[64]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat3dbar.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

(* Dipole 4 *)

If[dss[71] != 0,
WriteString[str3,"# M0=B4u: ",A4a1in," --> ", A4a1];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A4a1in,1];BL[2]=Part[A4a1in,2];
Do[BL[k+2]=Part[A4a1,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dCs;
writeshells[tempcount+1,tempcount+dss[71]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat4u.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[72] != 0,
WriteString[str3,"# M0=B4ubar: ",A4a2in," --> ", A4a2];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A4a2in,1];BL[2]=Part[A4a2in,2];
Do[BL[k+2]=Part[A4a2,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dCs+dss[71];
writeshells[tempcount+1,tempcount+dss[72]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat4ubar.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[73] != 0,
WriteString[str3,"# M0=B4d: ",A4a3in," --> ", A4a3];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A4a3in,1];BL[2]=Part[A4a3in,2];
Do[BL[k+2]=Part[A4a3,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dCs+dss[71]+dss[72];
writeshells[tempcount+1,tempcount+dss[73]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat4d.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

If[dss[74] != 0,
WriteString[str3,"# M0=B4dbar: ",A4a4in," --> ", A4a4];
WriteString[str3," \n"];
WriteString[str3,"touch tempc1 \n"];
WriteString[str3," \n"];
BL[1]=Part[A4a4in,1];BL[2]=Part[A4a4in,2];
Do[BL[k+2]=Part[A4a4,k],{k,1,nfinal-1}];
transtomad;
writemadproc;
WriteString[str3," \n"];
tempcount=dAs+dBs+dCs+dss[71]+dss[72]+dss[73];
writeshells[tempcount+1,tempcount+dss[74]];
WriteString[str3," \n"];
WriteString[str3,"mv tempc1 allcolormat4dbar.inc"];
WriteString[str3," \n"];
WriteString[str3," \n"];];

(* That is all *)
Do[
WriteString[str3,"rm -f color",i];
WriteString[str3," \n"];
,{i,1,dtotal}];

WriteString[str3," \n"];
WriteString[str3," \n"];
Close[str3];
]


transtomad:=Module[{},
Do[
If[BL[k]==u || BL[k]==d || BL[k]==b || BL[k]==t || BL[k]==g,ML[k]=BL[k]];
If[BL[k]==ubar, ML[k]="u~"];
If[BL[k]==dbar, ML[k]="d~"];
If[BL[k]==bbar, ML[k]="b~"];
If[BL[k]==tbar, ML[k]="t~"];
If[BL[k]==e,ML[k]="e-"];
If[BL[k]==ebar, ML[k]="e+"];
If[BL[k]==muon,ML[k]="mu-"];
If[BL[k]==muonbar, ML[k]="mu+"];
If[BL[k]==gamma, ML[k]="a"];
If[BL[k]==Wp, ML[k]="w+"];
If[BL[k]==Wm, ML[k]="w-"];
If[BL[k]==Z, ML[k]="z"];
If[BL[k]==h, ML[k]="h"];
,{k,1,nfinal+1}]
]


writemadproc:=Module[{},
WriteString[str3,"replace_input "];
WriteString[str3,"'",ML[1],ML[2],">"];
Do[WriteString[str3,ML[k]];,{k,3,nfinal+1}];
WriteString[str3,"'"];
WriteString[str3," \n"];
]


writeshells[sta_,fin_]:=Module[{},Do[
WriteString[str3,"replace "];
writeemitspec[emit[i],spec[i]];
WriteString[str3,"echo 'Color factor ",i,"'"];
WriteString[str3," \n"];
WriteString[str3,"colormake "];
WriteString[str3," \n"];
WriteString[str3,"modcolormatrix ",i];
WriteString[str3," \n"];
WriteString[str3,"cat tempc1 color",i," > tempc2"];
WriteString[str3," \n"];
WriteString[str3,"mv tempc2 tempc1"];
WriteString[str3," \n"];
WriteString[str3," \n"];
,{i,sta,fin}];]


writeemitspec[i_,j_]:=Module[{},
If[i==1 || i==2,
   If[BL[i]==u || BL[i]==d || BL[i]==b || BL[i]==t,
       WriteString[str3,i," 1 2"];];
   If[BL[i]==ubar || BL[i]==dbar || BL[i]==bbar || BL[i]==tbar,
       WriteString[str3,i," 2 2"]];
   If[BL[i]==g,
       WriteString[str3,i," 3 2"]];
];
If[3 <= i <= nfinal+2,
   If[BL[i]==u || BL[i]==d || BL[i]==b || BL[i]==t,
       WriteString[str3,i," 1 1"];];
   If[BL[i]==ubar || BL[i]==dbar || BL[i]==bbar || BL[i]==tbar,
       WriteString[str3,i," 2 1"]];
   If[BL[i]==g,
       WriteString[str3,i," 3 1"]];
]; 
If[j==1 || j==2,
   If[BL[j]==u || BL[j]==d || BL[j]==b || BL[j]==t,
       WriteString[str3," ",j," 1 2"];];
   If[BL[j]==ubar || BL[j]==dbar || BL[j]==bbar || BL[j]==tbar,
       WriteString[str3," ",j," 2 2"]];
   If[BL[j]==g,
       WriteString[str3," ",j," 3 2"]];
];
If[3 <= j <= nfinal+2,
   If[BL[j]==u || BL[j]==d || BL[j]==b || BL[j]==t,
       WriteString[str3," ",j," 1 1"];];
   If[BL[j]==ubar || BL[j]==dbar || BL[j]==bbar || BL[j]==tbar,
       WriteString[str3," ",j," 2 1"]];
   If[BL[j]==g,
       WriteString[str3," ",j," 3 1"]];
]; 
WriteString[str3," \n"];
];


(* 2.createamplitude *)


createamplitude:=Module[{},
namegetamplitudesh=StringJoin[targettempdir,"/getamplitude.sh"];
str4=OpenWrite[namegetamplitudesh];
WriteString[str4,"#!/bin/sh"];
WriteString[str4," \n \n"];
WriteString[str4,". ../../../lib/sh/AutoDipoleTool.sh"];
WriteString[str4," \n \n"];
WriteString[str4,"rm -f matrix.f cmatrix.f"];
WriteString[str4," \n \n"];
WriteString[str4,"rm -f cmatrix1.f cmatrix1dh.f \n"];
WriteString[str4,"rm -f cmatrix2u.f cmatrix2udh.f \n"];
WriteString[str4,"rm -f cmatrix2d.f cmatrix2ddh.f \n"];
WriteString[str4,"rm -f cmatrix2b.f cmatrix2bdh.f \n"];
WriteString[str4,"rm -f cmatrix2t.f cmatrix2tdh.f \n"];

WriteString[str4,"rm -f cmatrix3u.f \n"];
WriteString[str4,"rm -f cmatrix3ubar.f \n"];
WriteString[str4,"rm -f cmatrix3d.f \n"];
WriteString[str4,"rm -f cmatrix3dbar.f \n"]; 

WriteString[str4,"rm -f cmatrix4u.f cmatrix4udh.f \n"];
WriteString[str4,"rm -f cmatrix4ubar.f cmatrix4ubardh.f \n"];
WriteString[str4,"rm -f cmatrix4d.f cmatrix4ddh.f \n"];
WriteString[str4,"rm -f cmatrix4dbar.f cmatrix4dbardh.f \n"]; 
WriteString[str4,"rm -f inputm.h \n"];
WriteString[str4,"rm -f errorborn \n"];
WriteString[str4,"rm -f inputmLO.h matrixLO1.f pmassLO.inc"];
WriteString[str4,"\n\n"];
WriteString[str4,"touch temp.f \n"]; 
WriteString[str4," \n \n"];

(* Real process *)
WriteString[str4,"# Process:",{A[1],A[2]}," --> ",flistm];
WriteString[str4," \n"];
BL[1]=A[1];BL[2]=A[2];
Do[BL[k+2]=Part[flistm,k],{k,1,nfinal}];

Do[
If[BL[k]==u || BL[k]==d || BL[k]==b || BL[k]==t || BL[k]==g,ML[k]=BL[k]];
If[BL[k]==ubar, ML[k]="u~"];
If[BL[k]==dbar, ML[k]="d~"];
If[BL[k]==bbar, ML[k]="b~"];
If[BL[k]==tbar, ML[k]="t~"];
If[BL[k]==e,ML[k]="e-"];
If[BL[k]==ebar, ML[k]="e+"];
If[BL[k]==muon,ML[k]="mu-"];
If[BL[k]==muonbar, ML[k]="mu+"];
If[BL[k]==gamma, ML[k]="a"];
If[BL[k]==Wp, ML[k]="w+"];
If[BL[k]==Wm, ML[k]="w-"];
If[BL[k]==Z, ML[k]="z"];
If[BL[k]==h, ML[k]="h"];
,{k,1,nfinal+2}];

WriteString[str4,"replace_input_amp "];
WriteString[str4,"'",ML[1],ML[2],">"];
Do[WriteString[str4,ML[k]];,{k,3,nfinal+2}];
WriteString[str4,"'"];
WriteString[str4," \n"];

WriteString[str4,"replace_driver_normal"];
WriteString[str4," \n"];

Do[
If[BL[k]==u || BL[k]==d || BL[k]==b || BL[k]==t || BL[k]==g,ML[k]=BL[k]];
If[BL[k]==ubar, ML[k]="ux"];
If[BL[k]==dbar, ML[k]="dx"];
If[BL[k]==bbar, ML[k]="bx"];
If[BL[k]==tbar, ML[k]="tx"];
If[BL[k]==e,ML[k]="e-"];
If[BL[k]==ebar, ML[k]="e+"];
If[BL[k]==muon,ML[k]="mu-"];
If[BL[k]==muonbar, ML[k]="mu+"];
If[BL[k]==gamma, ML[k]="a"];
If[BL[k]==Wp, ML[k]="w+"];
If[BL[k]==Wm, ML[k]="w-"];
If[BL[k]==Z, ML[k]="z"];
If[BL[k]==h, ML[k]="h"];
,{k,1,nfinal+2}];

WriteString[str4,"ampmake "];
WriteString[str4,"'P0_",ML[1],ML[2],"_"];
Do[WriteString[str4,ML[k]];,{k,3,nfinal+2}];
WriteString[str4,"'"];
WriteString[str4," 'matrix.f'"];
WriteString[str4," \n"];
WriteString[str4,"getinputm "];
WriteString[str4,"'P0_",ML[1],ML[2],"_"];
Do[WriteString[str4,ML[k]];,{k,3,nfinal+2}];
WriteString[str4,"'"];
WriteString[str4," \n \n"];


(* Dipole 1 *)

If[dAs != 0,
WriteString[str4,"# M0=B1:",{A[1],A[2]}," --> ",A1];
WriteString[str4," \n"];
BL[1]=A[1];BL[2]=A[2];
Do[BL[k+2]=Part[A1,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

transtomaddir;
writegetLO[matrixLO1];

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix1.f'"];
WriteString[str4," '1'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix1.f' 'cmatrix1' 'mat1' 'cmatrix1mod.f' \n",
"cat temp.f cmatrix1mod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix1mod.f cmatrix1.f \n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix1dh.f'"];
WriteString[str4," '1dh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix1dh.f' 'cmatrix1dh' 'mat1dh' 'cmatrix1dhmod.f' 'mat1' \n",
"cat temp.f cmatrix1dhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix1dhmod.f cmatrix1dh.f \n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];


(* Dipole 2 *)

If[dss[51] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str4,"# M0=B2u:",{A[1],A[2]}," --> ", A2a1];
WriteString[str4," \n"];
Do[BL[k+2]=Part[A2a1,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;
(*WriteString[str4,"replace_driver_amp .false. .false.\n"];
writegetLO[matrixLO2u];*)
WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix2u.f'"];
WriteString[str4," '2u'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix2u.f' 'cmatrix2u' 'mat2u' 'cmatrix2umod.f' \n",
"cat temp.f cmatrix2umod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2umod.f cmatrix2u.f \n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix2udh.f'"];
WriteString[str4," '2udh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix2udh.f' 'cmatrix2udh' 'mat2udh' 'cmatrix2udhmod.f' 'mat2u' \n",
"cat temp.f cmatrix2udhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2udhmod.f cmatrix2udh.f \n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];


If[dss[53] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str4,"# M0=B2d:",{A[1],A[2]}," --> ", A2a2];
WriteString[str4," \n"];
Do[BL[k+2]=Part[A2a2,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;
(*WriteString[str4,"replace_driver_amp .false. .false.\n"];
writegetLO[matrixLO2ubar];*)
WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix2d.f'"];
WriteString[str4," '2d'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix2d.f' 'cmatrix2d' 'mat2d' 'cmatrix2dmod.f' \n",
"cat temp.f cmatrix2dmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2dmod.f cmatrix2d.f \n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix2ddh.f'"];
WriteString[str4," '2ddh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix2ddh.f' 'cmatrix2ddh' 'mat2ddh' 'cmatrix2ddhmod.f' 'mat2d' \n",
"cat temp.f cmatrix2ddhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2ddhmod.f cmatrix2ddh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];

If[dss[57] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str4,"# M0=B2b:",{A[1],A[2]}," --> ", A2a4];
WriteString[str4," \n"];
Do[BL[k+2]=Part[A2a4,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;
(*WriteString[str4,"replace_driver_amp .false. .false.\n"];
writegetLO[matrixLO2d];*)
WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix2b.f'"];
WriteString[str4," '2b'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix2b.f' 'cmatrix2b' 'mat2b' 'cmatrix2bmod.f' \n",
"cat temp.f cmatrix2bmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2bmod.f cmatrix2b.f\n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix2bdh.f'"];
WriteString[str4," '2bdh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix2bdh.f' 'cmatrix2bdh' 'mat2bdh' 'cmatrix2bdhmod.f' 'mat2b' \n",
"cat temp.f cmatrix2bdhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2bdhmod.f cmatrix2bdh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];

If[dss[58] != 0,
BL[1]=A[1];BL[2]=A[2];
WriteString[str3,"# M0=B2t:",{A[1],A[2]}," --> ", A2a3];
WriteString[str3," \n"];
Do[BL[k+2]=Part[A2a3,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;
WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix2t.f'"];
WriteString[str4," '2t'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix2t.f' 'cmatrix2t' 'mat2t' 'cmatrix2tmod.f' \n",
"cat temp.f cmatrix2tmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2tmod.f cmatrix2t.f\n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix2tdh.f'"];
WriteString[str4," '2tdh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix2tdh.f' 'cmatrix2tdh' 'mat2tdh' 'cmatrix2tdhmod.f' 'mat2t' \n",
"cat temp.f cmatrix2tdhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix2tdhmod.f cmatrix2tdh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];


(* Dipole 3 *)

If[dss[61] != 0,
WriteString[str4,"# M0=B3u:",A3a1in," --> ", A3a1];
WriteString[str4," \n"];
BL[1]=Part[A3a1in,1];BL[2]=Part[A3a1in,2];
Do[BL[k+2]=Part[A3a1,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];
transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix3u.f'"];
WriteString[str4," '3u'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix3u.f' 'cmatrix3u' 'mat3u' 'cmatrix3umod.f' \n",
"cat temp.f cmatrix3umod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3umod.f cmatrix3u.f\n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix3udh.f'"];
WriteString[str4," '3udh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix3udh.f' 'cmatrix3udh' 'mat3udh' 'cmatrix3udhmod.f' 'mat3u' \n",
"cat temp.f cmatrix3udhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3udhmod.f cmatrix3udh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];

If[dss[62] != 0,
WriteString[str4,"# M0=B3ubar:",A3a2in," --> ", A3a2];
WriteString[str4," \n"];
BL[1]=Part[A3a2in,1];BL[2]=Part[A3a2in,2];
Do[BL[k+2]=Part[A3a2,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix3ubar.f'"];
WriteString[str4," '3ubar'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix3ubar.f' 'cmatrix3ubar' 'mat3ubar' 'cmatrix3ubarmod.f' \n",
"cat temp.f cmatrix3ubarmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3ubarmod.f cmatrix3ubar.f\n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix3ubardh.f'"];
WriteString[str4," '3ubardh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix3ubardh.f' 'cmatrix3ubardh' 'mat3ubardh' 'cmatrix3ubardhmod.f' 'mat3ubar' \n",
"cat temp.f cmatrix3ubardhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3ubardhmod.f cmatrix3ubardh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];

If[dss[63] != 0,
WriteString[str4,"# M0=B3d:",A3a3in," --> ", A3a3];
WriteString[str4," \n"];
BL[1]=Part[A3a3in,1];BL[2]=Part[A3a3in,2];
Do[BL[k+2]=Part[A3a3,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix3d.f'"];
WriteString[str4," '3d'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix3d.f' 'cmatrix3d' 'mat3d' 'cmatrix3dmod.f' \n",
"cat temp.f cmatrix3dmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3dmod.f cmatrix3d.f\n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix3ddh.f'"];
WriteString[str4," '3ddh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix3ddh.f' 'cmatrix3ddh' 'mat3ddh' 'cmatrix3ddhmod.f' 'mat3d' \n",
"cat temp.f cmatrix3ddhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3ddhmod.f cmatrix3ddh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];

If[dss[64] != 0,
WriteString[str4,"# M0=B3dbar:",A3a4in," --> ", A3a4];
WriteString[str4," \n"];
BL[1]=Part[A3a4in,1];BL[2]=Part[A3a4in,2];
Do[BL[k+2]=Part[A3a4,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix3dbar.f'"];
WriteString[str4," '3dbar'"];
WriteString[str4," \n"];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

WriteString[str4,"cmatriximod 'cmatrix3dbar.f' 'cmatrix3dbar' 'mat3dbar' 'cmatrix3dbarmod.f' \n",
"cat temp.f cmatrix3dbarmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3dbarmod.f cmatrix3dbar.f\n \n"];

WriteString[str4,"replace_driver_amp .true."];
WriteString[str4," \n"];
writeampmake;
WriteString[str4," 'cmatrix3dbardh.f'"];
WriteString[str4," '3dbardh'"];
WriteString[str4," \n"];
WriteString[str4,"cmatrixidhmod 'cmatrix3dbardh.f' 'cmatrix3dbardh' 'mat3dbardh' 'cmatrix3dbardhmod.f' 'mat3dbar' \n",
"cat temp.f cmatrix3dbardhmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix3dbardhmod.f cmatrix3dbardh.f\n"];
WriteString[str4,"fi \n"];
WriteString[str4,"fi \n"];
WriteString[str4," \n \n"];
];

(* Dipole 4 *)

If[dss[71] != 0,
WriteString[str4,"# M0=B4u: ",A4a1in," --> ", A4a1];
WriteString[str4," \n"];
BL[1]=Part[A4a1in,1];BL[2]=Part[A4a1in,2];
Do[BL[k+2]=Part[A4a1,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix4u.f'"];
WriteString[str4," '4u'"];
WriteString[str4," \n"];
WriteString[str4,"cmatriximod 'cmatrix4u.f' 'cmatrix4u' 'mat4u' 'cmatrix4umod.f' \n",
"cat temp.f cmatrix4umod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix4umod.f cmatrix4u.f\n \n"];
WriteString[str4,"fi \n"];
];

If[dss[72] != 0,
WriteString[str4,"# M0=B4ubar: ",A4a2in," --> ", A4a2];
WriteString[str4," \n"];
BL[1]=Part[A4a2in,1];BL[2]=Part[A4a2in,2];
Do[BL[k+2]=Part[A4a2,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix4ubar.f'"];
WriteString[str4," '4ubar'"];
WriteString[str4," \n"];
WriteString[str4,"cmatriximod 'cmatrix4ubar.f' 'cmatrix4ubar' 'mat4ubar' 'cmatrix4ubarmod.f' \n",
"cat temp.f cmatrix4ubarmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix4ubarmod.f cmatrix4ubar.f\n \n"];
WriteString[str4,"fi \n"];
];

If[dss[73] != 0,
WriteString[str4,"# M0=B4d: ",A4a3in," --> ", A4a3];
WriteString[str4," \n"];
BL[1]=Part[A4a3in,1];BL[2]=Part[A4a3in,2];
Do[BL[k+2]=Part[A4a3,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix4d.f'"];
WriteString[str4," '4d'"];
WriteString[str4," \n"];
WriteString[str4,"cmatriximod 'cmatrix4d.f' 'cmatrix4d' 'mat4d' 'cmatrix4dmod.f' \n",
"cat temp.f cmatrix4dmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix4dmod.f cmatrix4d.f\n \n"];
WriteString[str4,"fi \n"];
];

If[dss[74] != 0,
WriteString[str4,"# M0=B4dbar: ",A4a4in," --> ", A4a4];
WriteString[str4," \n"];
BL[1]=Part[A4a4in,1];BL[2]=Part[A4a4in,2];
Do[BL[k+2]=Part[A4a4,k],{k,1,nfinal-1}];

WriteString[str4,"if [ -f ./errorborn ]\n"];
WriteString[str4,"then\n"];
WriteString[str4,"echo 'Skipped' \n"];
WriteString[str4,"else \n"];

transtomad;
writemadprocamp;

WriteString[str4,"replace_driver_amp .false."];
WriteString[str4," \n"];
transtomaddir;
writeampmake;
WriteString[str4," 'cmatrix4dbar.f'"];
WriteString[str4," '4dbar'"];
WriteString[str4," \n"];
WriteString[str4,"cmatriximod 'cmatrix4dbar.f' 'cmatrix4dbar' 'mat4dbar' 'cmatrix4dbarmod.f' \n",
"cat temp.f cmatrix4dbarmod.f > temp2.f \n",
"mv temp2.f temp.f \n",
"rm cmatrix4dbarmod.f cmatrix4dbar.f\n \n"];
WriteString[str4,"fi \n"];
];

WriteString[str4,"mv temp.f cmatrix.f \n"];
Close[str4];
]


writemadprocamp:=Module[{},
WriteString[str4,"replace_input_amp "];
WriteString[str4,"'",ML[1],ML[2],">"];
Do[WriteString[str4,ML[k]];,{k,3,nfinal+1}];
WriteString[str4,"'"];
WriteString[str4," \n"];
]


transtomaddir:=Module[{},
Do[
If[BL[k]==u || BL[k]==d || BL[k]==b || BL[k]==t || BL[k]==g,ML[k]=BL[k]];
If[BL[k]==ubar, ML[k]="ux"];
If[BL[k]==dbar, ML[k]="dx"];
If[BL[k]==bbar, ML[k]="bx"];
If[BL[k]==tbar, ML[k]="tx"];
If[BL[k]==e,ML[k]="e-"];
If[BL[k]==ebar, ML[k]="e+"];
If[BL[k]==muon,ML[k]="mu-"];
If[BL[k]==muonbar, ML[k]="mu+"];
If[BL[k]==gamma, ML[k]="a"];
If[BL[k]==Wp, ML[k]="w+"];
If[BL[k]==Wm, ML[k]="w-"];
If[BL[k]==Z, ML[k]="z"];
If[BL[k]==h, ML[k]="h"];
,{k,1,nfinal+1}]
]


writeampmake:=Module[{},
WriteString[str4,"ampmake "];
WriteString[str4,"'P0_",ML[1],ML[2],"_"];
Do[WriteString[str4,ML[k]];,{k,3,nfinal+1}];
WriteString[str4,"'"];
]


writegetLO[matrixLO_]:=Module[{},
WriteString[str4,"getLO "];
WriteString[str4,"'P0_",ML[1],ML[2],"_"];
Do[WriteString[str4,ML[k]];,{k,3,nfinal+1}];
WriteString[str4,"'"];
WriteString[str4," '",matrixLO,".f'"];
WriteString[str4,"\n"];
]


(* 3.createemitspecinfo *)


createemitspecinfo:=Module[{},
nameemitspecinfoinc=StringJoin[targetdir,"/emitspecinfo.inc"];
str5=OpenWrite[nameemitspecinfoinc];
WriteString[str5,"      integer tdn,emi(",dtotal,")"];
WriteString[str5," \n"];
WriteString[str5,"       parameter (tdn=",dtotal,")"];
WriteString[str5," \n"];
Do[
WriteString[str5,"       data emi(",i,")/",emit[i],"/"];
WriteString[str5," \n"];
,{i,1,dtotal}];
WriteString[str5," \n"];
Close[str5];
]


(* 4.createnexternal *)


createnexternal:=Module[{},
namenexternalinc=StringJoin[targetdir,"/nexternal.inc"];
str6=OpenWrite[namenexternalinc];
WriteString[str6,
"      integer    nexternal \n",
"      parameter (nexternal=  ",nfinal+2,") \n",
"      integer    nincoming \n",
"      parameter (nincoming=  2) \n"];
Close[str6];
namenexternal2inc=StringJoin[targetdir,"/nexternal2.inc"];
str7=OpenWrite[namenexternal2inc];
WriteString[str7,
"      integer    nexternal2 \n",
"      parameter (nexternal2=  ",nfinal+1,") \n",
"      integer    nincoming \n",
"      parameter (nincoming=  2) \n"];
Close[str7];
]


(* 5.write check.f *)


writecheck:=Module[{},
namecheckf=StringJoin[targetdir,"/check.f"];
str8=OpenWrite[namecheckf];
WriteString[str8,
"c Generated by AutoDipole Version 1.2, \n",
"c Kouhei Hasegawa, Sven Moch, and Peter Uwer \n",
"c \n"];
WriteString[str8,
"      program checkdipole\n",
"      implicit none\n\n",
"      integer i,k\n",
"      double precision p(0:3,1:",nfinal+2,"),dip(",dtotal,"),SumD,msq,acc,m2,AL,ratio,mt,mb\n",
"      common /INPUTM/ p\n",
"      common /MADMS/ m2\n",
"      common /usedalpha/ AL\n",
"      common /MASS/ mt,mb\n",
"      include 'coupl.inc'\n",
"      include 'nexternal.inc'\n",
"      call setpara('param_card.dat',.true.)\n",
"      AL=g**2*(4.d0*3.141592653589793238D0)**(-1)\n",
"      mt=tmass\n",
"      mb=bmass\n",
"      write(*,*) '          |M|^2                      SumDipole\n",
"     &          |M|^2 - SumDipole'\n",
"       \n",
"      do i=1,10\n",
"       call readmomenta\n",
"       call smatrix(p,msq)\n",
"       call dipole(p,dip,SumD)\n",
"       write(*,'(1x,i3,1x,3e27.15)') i,msq,SumD,msq-SumD\n",
"       enddo\n",
"      end\n",
"       \n",
"       \n",
"      subroutine readmomenta\n",
"      implicit none\n",
"      integer idy1\n",
"      double precision m2\n",
"      double precision p(0:3,1:",nfinal+2,")\n",
"      common /INPUTM/ p\n",
"      common /MADMS/ m2\n",
"       \n",
"      open (unit=11, file ='inputm.h', status = 'old')\n"
];
Do[WriteString[str8,
"      read  (11,*) idy1, p(0,",i,"), p(1,",i,"), p(2,",i,"), p(3,",i,")\n"
],{i,1,nfinal+2}];
WriteString[str8,"      read  (11,*) m2"];
WriteString[str8,"  \n\n",
"      return\n",
"      end\n",
"       \n"
];
Close[str8];
]


(* 6.write checkIR.f *)


writecheckIR:=Module[{},
namecheckIRf=StringJoin[targetdir,"/checkIR.f"];
str9=OpenWrite[namecheckIRf];
writecheckIRbegin;
Do[ 
If[ FreeQ[collinearmassive,k],
If[ Part[collinear[k],1] >= 3,writecollinearFF];
If[ Part[collinear[k],1] <= 2,writecollinearIF];
];
If[ MemberQ[collinearmassive,k],writecollinearmassive]
,{k,1,ncoll}];
writeIRsafeprint;
WriteString[str9,"      end \n",
"       \n",
"      subroutine accuracy(standard,objective,ratio,acc)\n",
"      implicit none\n",
"      double precision standard,objective,ratio,acc\n",
"      ratio = objective/standard\n",
"      acc = (standard - objective)/standard\n",
"      return\n",
"      end\n"
];
Close[str9];
]


writecheckIRbegin:=Module[{},
WriteString[str9,
"c Generated by AutoDipole Version 1.2, \n",
"c Kouhei Hasegawa, Sven Moch, and Peter Uwer \n",
"c \n"];
WriteString[str9,
"      program checkIR\n",
"      implicit none\n\n",
"      INTEGER I,J,K,l,coun(",ncoll,"),nfin,err\n",
"      real*8 ZERO\n",
"      PARAMETER (ZERO=0D0)\n",
"      include 'nexternal.inc'\n",
"      real*8 PMASS(NEXTERNAL),PMASS1(NEXTERNAL-1)\n",
"      real*8 P(0:3,NEXTERNAL),Q(0:3,NEXTERNAL-1),R(0:3,NEXTERNAL)\n",
"      real*8 collmass,collmom(0:3),thetacoll,rootsij,horizon\n",
"      real*8 SQRTS\n",
"      real*8 DOT\n",
"      real*8 costheta,sintheta,cphi,sphi\n",
"      real*8 costhetacoll,sinthetacoll\n",
"      real*8 costhetaprime,sinthetaprime\n",
"      real*8 delta,cut(",ncoll,"),cutmax,cutmaxsij,acccut\n",
"      real*8 energy,s,jacobi,scutmax,scutmaxratio\n",
"      real*8 x(3*nexternal-10),m(nexternal-2)\n",
"      real*8 pset(4,nexternal-2)\n",
"      double precision dip(",dtotal,"),SumD,msq,acc,m2,AL,ratio,mt,mb\n",
"      common /MADMS/ m2\n",
"      common /usedalpha/ AL\n",
"      common /MASS/ mt,mb\n",
"      include 'coupl.inc'\n",
"      call setpara('param_card.dat',.true.)\n",
"      AL=g**2*(4.d0*3.141592653589793238D0)**(-1)\n",
"      mt=tmass\n",
"      mb=bmass\n",
"      include 'pmass.inc'\n",
"      pmass1(1)=pmass(1)\n",
"      pmass1(2)=pmass(2)\n",
"      \n",
"      SQRTS=1000d0\n",
"      s=SQRTS**2\n",
"      nfin=nexternal-2\n",
"      do i=1,",ncoll,"\n",
"      coun(i)=0\n",
"      cut(i)=1.d0\n",
"      enddo \n",
"      acccut=",FortranForm[acccut],"d0\n",
" \n"
];
]


writecollinearFF:=Module[{},
WriteString[str9,"C      FF\n",
"C     Collinear limit ",k,". ",collinear[k],"\n",
"      open(Unit=3,File='collinear",k,".dat',Status='replace')\n",
"      do l = 1,1000\n",
"      collmass=10.d0*1.01d0**(-l)\n"];
Do[
If[n == Part[collinear[k],1],WriteString[str9,
"      pmass1(",n,")=collmass\n"]];
If[n != Part[collinear[k],1] && n <= Part[collinear[k],2]-1 ,WriteString[str9,
"      pmass1(",n,")=pmass(",n,")\n"]];
If[n >= Part[collinear[k],2]+1 ,WriteString[str9,
"      pmass1(",n-1,")=pmass(",n,")\n"]];
,{n,3,nfinal+2}];
WriteString[str9,
(*"      pmass1(  ",Part[collinear[k],1],")=collmass\n",*)
"      CALL GET_MOMENTA_ff(SQRTS,PMASS1,Q)\n",
"      do i=0,3\n",
"      P(i,1)=Q(i,1)\n",
"      P(i,2)=Q(i,2)\n"];
Do[
If[n != Part[collinear[k],1] && n <= Part[collinear[k],2]-1 ,WriteString[str9,
"      P(i,",n,")=Q(i,",n,")\n"]];
If[n >= Part[collinear[k],2]+1 ,WriteString[str9,
"      P(i,",n,")=Q(i,",n-1,")\n"]];
,{n,3,nfinal+2}];
WriteString[str9,
"      enddo\n",
"      do i=0,3\n",
"       collmom(i)=Q(i,",Part[collinear[k],1],")\n",
"      enddo\n",
"      call maptocollinear_ff(collmass,collmom,P(0,",Part[collinear[k],1],
"),P(0,",Part[collinear[k],2],"),thetacoll,\n",
"     & rootsij)\n",
"      horizon=dlog10(rootsij*SQRTS**(-1))\n",
"c      call showmomenta(nexternal,P,thetacoll,horizon)\n",
"      call smatrix(p,msq)\n",
"      call dipole(p,dip,SumD)\n",
"      SumD=dip(",Part[collineardipoles[k],1],")"];
If[ Length[collineardipoles[k]] >= 2,
Do[
WriteString[str9,"+dip(",Part[collineardipoles[k],n],")"],
{n,2,Length[collineardipoles[k]]}]];
WriteString[str9,
"\n",
"      call accuracy(msq,SumD,ratio,acc)\n",
"      write(3,'(1x,i4,5e25.15)') l,horizon,msq,SumD,ratio,acc\n",
"      If (dabs(acc) .le. acccut .and. coun(",k,") .ne. 1 ) then\n",
"      cut(",k,")=horizon\n",
"      coun(",k,")=coun(",k,")+1\n",
"      endif\n",
"      enddo\n",
"      close(unit=3)\n",
" \n"
];
]


writecollinearIF:=Module[{},
WriteString[str9,"C      IF\n",
"C     Collinear limit ",k,". ",collinear[k],"\n",
"      open(Unit=3,File='collinear",k,".dat',Status='replace')\n",
"      call GET_MOMENTA(SQRTS,PMASS,R)\n",
"      call getthetaphi(R(0,",Part[collinear[k],2],"),costheta,sintheta,cphi,sphi)\n",
"      do i=0,3\n",
"      do k=1,2\n",
"      P(i,k)=R(i,k)\n",
"      enddo\n",
"      enddo\n",
"      do l = 1,1000\n",
"      delta=1.d0*1.015d0**(-l)\n",
"      call maptocollinear_if(R(0,",Part[collinear[k],2],"),delta,costheta,sintheta,cphi,sphi,\n",
"     &          P(0,",Part[collinear[k],2],"),costhetaprime,sinthetaprime,thetacoll)\n"];
Do[If[n != Part[collinear[k],2],
WriteString[str9,"      call othmom(R(0,",n,"),cphi,sphi,costhetaprime,sinthetaprime,p(0,",n,"))\n"]]
,{n,3,nfinal+2}];
If[Part[collinear[k],1] == 2,
WriteString[str9, 
"      do i=1,3\n",
"      do k=3,nexternal\n",
"      P(i,k)=-P(i,k)\n",
"      enddo\n",
"      enddo\n"
];
];
WriteString[str9,
"      rootsij=dsqrt(dabs(2.d0*DOT(p(0,",Part[collinear[k],1],"),p(0,",Part[collinear[k],2],"))))\n",
"      horizon=dlog10(rootsij*SQRTS**(-1))\n",
"c      call showmomenta(nexternal,P,thetacoll,horizon)\n",
"      call smatrix(p,msq)\n",
"      call dipole(p,dip,SumD)\n",
"      SumD=dip(",Part[collineardipoles[k],1],")"];
Do[
WriteString[str9,"+dip(",Part[collineardipoles[k],n],")"],
{n,2,Length[collineardipoles[k]]}];
WriteString[str9,
"\n",
"      call accuracy(msq,SumD,ratio,acc)\n",
"      write(3,'(1x,i4,5e25.15)') l,horizon,msq,SumD,ratio,acc\n",
"      If (dabs(acc) .le. acccut .and. coun(",k,") .ne. 1 ) then\n",
"      cut(",k,")=horizon\n",
"      coun(",k,")=coun(",k,")+1\n",
"      endif\n",
"      enddo\n",
"      close(unit=3)\n",
" \n"
];
]


writecollinearmassive:=Module[{},
WriteString[str9,
"C     Collinear limit ",k,". ",collinear[k]," includes a massive quark\n",
"      cut(",k,")=-100.d0\n",
" \n"]
 ]


writeIRsafeprint:=Module[{},
WriteString[str9,
"      open(Unit=3,File='resIRcheck',Status='replace')\n",
"      cutmax=-10.d0\n",
"      scutmax=-10.d0\n",
"      do i=1,",ncoll,"\n",
"      cutmax=dmax1(cutmax,cut(i))\n",
"      enddo\n",
"      cutmaxsij=10**(2.D0*cutmax)\n",
"      write(3,'(a35,1e23.15)') 'Cut condition: (|M|^2-SumD)/|M|^2 <',\n",
"     & acccut\n",
"      write(3,*) ' '\n",
"      write(3,*) '----------Collinear limits----------'\n",
"      write(3,'(a36)') 'Log10(Root(S_ij/S)) < Cut(i) (i=1,",ncoll,")'\n",
"      do i=1,",ncoll,"\n",
"      write(3,'(1x,i4,1e25.15)') i,cut(i)\n",
"      enddo\n",
"      write(3,*) 'Maximum value of Cut(i)'\n",
"      write(3,'(1x,1e25.15)') cutmax\n",
"      write(3,*) 'Corresponding S_ij/S'\n",
"      write(3,'(1x,1e25.15)') cutmaxsij\n",
"      write(3,*) '------------------------------------'\n",
"      write(3,*) ' '\n",
"      If (cutmaxsij .lt. 1.0d-1 ) then\n",
"      write(3,*) 'Infrared safety of all collinear limits is confirmed',\n",
"     &' for'\n",
"      write(3,'(a13,1e22.15)') 'S_ij/S >', cutmaxsij\n",
"      write(*,*) '-----------------------------------------------------'\n",
"      write(*,*) 'Infrared safety of all collinear limits is confirmed',\n",
"     &' for'\n",
"      write(*,'(a13,1e22.15)') 'S_ij/S >', cutmaxsij\n",
"      write(*,*) '-----------------------------------------------------'\n",
"      else\n",
"      write(3,*) 'Infrared safety of all collinear limits is not',\n",
"     &' confirmed'\n",
"      write(*,*) '------------------------------------'\n",
"      write(*,*) 'Infrared safety of all collinear limits is not',\n",
"     &' confirmed'\n",
"      write(*,*) '------------------------------------'\n",
"      endif\n",
"      close(unit=3)\n"];
]
