#!/bin/sh 

sleep 3

HOMEPATH=`pwd`
echo 'Package home'
echo $HOMEPATH
LIBPATH=$HOMEPATH/lib
echo 'lib directory'
echo $LIBPATH
MATHPATH=$LIBPATH/math
echo 'math directory'
echo $MATHPATH
PROCESSPATH=$HOMEPATH/process
echo 'process directory'
echo $PROCESSPATH
PATCHEDMG_ME=$HOMEPATH/patch

VAR1=$1

echo 'New Process and directory ./process/'
echo $VAR1 
echo 'is created by Mathematica code'

# Get amplitude file without color factors: cmatrix.f
cd $PROCESSPATH/"$VAR1"/temp/
echo 'Execute getamplitude.sh in'
echo `pwd`
chmod +x getamplitude.sh
./getamplitude.sh


if [ -f ./errorborn ]
then
cat errorborn
exit 0
fi

# Get extended color factors: allcolormat*.inc
echo 'Execute colortarget.sh in'
echo `pwd`
chmod +x getallcolor.sh
./getallcolor.sh

echo 'Run of MadGraph has been succeeded.'
echo ' '


# Construct directory which can run
echo 'Consrtuct directory'
rm -r getamplitude.sh getallcolor.sh
ed inputm.h <<EOF
1,2d
wq
EOF
ed inputmLO.h <<EOF
1,2d
wq
EOF
mv -f matrix.f cmatrix.f inputm.h pmass.inc $PROCESSPATH/"$VAR1"/
mv -f allcolormat*.inc $PROCESSPATH/"$VAR1"/

cd $PROCESSPATH/"$VAR1"/
echo `pwd`

echo 'Before reducedm mod'
if grep -q "\\\\" "reducedm.f"
then
ed reducedm.f <<EOF
,s/\\\\//g
wq
EOF
fi

echo 'Before dipole mod'
if grep -q "\\\\" "dipole.f"
then
ed dipole.f <<EOF
,s/\\\\//g
wq
EOF
fi
echo 'After dipole mod'

ln -fs $LIBPATH/fortran/rambo.f .
ln -fs $LIBPATH/fortran/collinear.f .
ln -fs $LIBPATH/patch/couplings.f .
ln -fs $LIBPATH/make/makefile .
ln -fs $PATCHEDMG_ME/Models/sm/coupl.inc .
ln -fs $PATCHEDMG_ME/Models/sm/param_card.dat .
ln -fs $PATCHEDMG_ME/MyProcDir/lib/libdhelas3.a .
cp -f $LIBPATH/fortran/readme ./

if [ -d ./Virtual ]
then
cp -f ./temp/matrixLO1.f ./temp/inputmLO.h ./temp/pmassLO.inc ./Virtual/
echo 'Before I term mod'
if grep -q "\\\\" "./Virtual/Iterm.f"
then
ed ./Virtual/Iterm.f <<EOF
,s/\\\\//g
wq
EOF
fi

cd ./Virtual
ln -fs $LIBPATH/fortran/dilog.f .
ln -fs $LIBPATH/patch/couplings.f .
ln -fs $LIBPATH/make/makefile .
ln -fs $PATCHEDMG_ME/Models/sm/coupl.inc .
ln -fs $PATCHEDMG_ME/Models/sm/param_card.dat .
ln -fs ../cmatrix.f .
ln -fs ../emitspecinfo.inc .
ln -fs ../nexternal2.inc .
ln -fs ../allcolormat*.inc .
ln -fs ../libdhelas3.a .
cd ../
fi

if [ -d ./PK ]
then
mv -f ./temp/matrixLO1.f ./temp/inputmLO.h ./temp/pmassLO.inc ./PK/
echo 'Before PK mod'
if grep -q "\\\\" "./PK/PKterm.f"
then
ed ./PK/PKterm.f <<EOF
,s/\\\\//g
wq
EOF
fi

cd ./PK/
ln -fs $LIBPATH/patch/couplings.f .
ln -fs $LIBPATH/make/makefile .
ln -fs $PATCHEDMG_ME/Models/sm/coupl.inc .
ln -fs $PATCHEDMG_ME/Models/sm/param_card.dat .
ln -fs ../cmatrix.f .
ln -fs ../emitspecinfo.inc .
ln -fs ../nexternal2.inc .
ln -fs ../allcolormat*.inc .
ln -fs ../libdhelas3.a .
cd ../
else
rm -f ./temp/matrixLO1.f ./temp/inputmLO.h ./temp/pmassLO.inc
fi

rm -r temp
rm -r $PATCHEDMG_ME/MyProcDir/proc_log.txt
rm -r $PATCHEDMG_ME/MyProcDir/SubProcesses/P0*
rm -r $PATCHEDMG_ME/MyProcDir/SubProcesses/colormatrix.data
rm -r $PATCHEDMG_ME/MyProcDir/Cards/proc_card.dat
rm -r $PATCHEDMG_ME/MadGraphII/driver.f
rm -r $PATCHEDMG_ME/MadGraphII/driver.o
rm -r $PATCHEDMG_ME/MadGraphII/mg2_sa


echo ' '
echo '******************************************************'
echo 'Run has been succeeded.'
echo 'In order to run the generated code, please enter'
echo 'in the newly created directory under ./process'
echo 'make'
echo './runD'
echo '******************************************************'
echo ' '


